
package war;
/**
 *
 * @author Andrés Mella Romero
 */
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

class Combatiente {

    public final static String SEPARATOR_CHAR = ";";
    public final static String ENEMIGO_CHAR = "E";
    public final static String ALIADO_CHAR = "A";

    private String nombre;
    private Integer atributo01;
    private Integer atributo02;
    private Integer atributo03;
    private String localidad;

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public Integer getAtributo01() {
        return atributo01;
    }

    public void setAtributo01(Integer atributo01) {
        this.atributo01 = atributo01;
    }

    public Integer getAtributo02() {
        return atributo02;
    }

    public void setAtributo02(Integer atributo02) {
        this.atributo02 = atributo02;
    }

    public Integer getAtributo03() {
        return atributo03;
    }

    public void setAtributo03(Integer atributo03) {
        this.atributo03 = atributo03;
    }

    public String getLocalidad() {
        return localidad;
    }

    public void setLocalidad(String localidad) {
        this.localidad = localidad;
    }

    @Override
    public String toString() {

        StringBuilder sb = new StringBuilder();

        sb.append(this.nombre).append(SEPARATOR_CHAR);
        sb.append(this.atributo01).append(SEPARATOR_CHAR);
        sb.append(this.atributo02).append(SEPARATOR_CHAR);
        if (null != this.localidad) {
            sb.append(this.localidad).append(SEPARATOR_CHAR);
        }

        sb.append(this.atributo03);

        return sb.toString();

    }

}

class Aliado extends Combatiente {

    @Override
    public String toString() {

        StringBuilder sb = new StringBuilder();

        sb.append(Combatiente.ALIADO_CHAR).append(Combatiente.SEPARATOR_CHAR);
        sb.append(super.toString());

        return sb.toString();
    }

}

class Enemigo extends Combatiente {

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();

        sb.append(Combatiente.ENEMIGO_CHAR).append(Combatiente.SEPARATOR_CHAR);
        sb.append(super.toString());

        return sb.toString();
    }
}

public class War {

    public static void main(String[] args) throws IOException {
        BufferedReader reader = null;
        try {

            final String COMBATIENTES_CHAR = ":";
            int numeroLinea = 1;
            Combatiente[] enemigos = null;
            Combatiente[] aliados = null;

            int ultimoEmemigo = 0;
            int ultimoAliado = 0;
            int tokens = 0;
            StringTokenizer st = null;

            String typoCombatiente = null;

            reader = new BufferedReader(new FileReader("archivo1.txt"));

            String linea = reader.readLine();

            while (linea != null) {

                if (numeroLinea < 3) {

                    st = new StringTokenizer(linea, COMBATIENTES_CHAR);
                    typoCombatiente = st.nextToken();
                    Integer cantidad = Integer.valueOf(st.nextToken());

                    if (Combatiente.ENEMIGO_CHAR.equals(typoCombatiente.substring(0, 1))) {

                        enemigos = new Enemigo[cantidad];
                    } else if (Combatiente.ALIADO_CHAR.equals(typoCombatiente.substring(0, 1))) {

                        aliados = new Aliado[cantidad];
                    }

                } else {

                    st = new StringTokenizer(linea, Combatiente.SEPARATOR_CHAR);

                    tokens = st.countTokens();

                    typoCombatiente = st.nextToken();

                    if (Combatiente.ENEMIGO_CHAR.equals(typoCombatiente)) {

                        enemigos[ultimoEmemigo] = new Enemigo();

                        enemigos[ultimoEmemigo].setNombre(st.nextToken());
                        enemigos[ultimoEmemigo].setAtributo01(Integer.valueOf(st.nextToken()));
                        enemigos[ultimoEmemigo].setAtributo02(Integer.valueOf(st.nextToken()));

                        if (6 == tokens) {
                            enemigos[ultimoEmemigo].setLocalidad(st.nextToken());
                            enemigos[ultimoEmemigo].setAtributo03(Integer.valueOf(st.nextToken()));
                        } else if (5 == tokens) {
                            enemigos[ultimoEmemigo].setAtributo03(Integer.valueOf(st.nextToken()));
                        }

                        ultimoEmemigo++;

                    } else if (Combatiente.ALIADO_CHAR.equals(typoCombatiente)) {

                        aliados[ultimoAliado] = new Aliado();
                        aliados[ultimoAliado].setNombre(st.nextToken());
                        aliados[ultimoAliado].setAtributo01(Integer.valueOf(st.nextToken()));
                        aliados[ultimoAliado].setAtributo02(Integer.valueOf(st.nextToken()));
                        if (6 == tokens) {
                            aliados[ultimoAliado].setLocalidad(st.nextToken());
                            aliados[ultimoAliado].setAtributo03(Integer.valueOf(st.nextToken()));
                        } else if (5 == tokens) {
                            aliados[ultimoAliado].setAtributo03(Integer.valueOf(st.nextToken()));
                        }

                        ultimoAliado++;
                    }

                }

                linea = reader.readLine();

                numeroLinea++;

            }

            //Imprimir los combatientes
            for (Combatiente c : enemigos) {
                System.out.println(c.toString());
            }

            for (Combatiente c : aliados) {
                System.out.println(c.toString());
            }

        } catch (Exception e) {
            
            System.out.println("Error al leer");

        } finally {
            if (null != reader) {
                reader.close();
            }
        }

    }

}
